function PlaylistController(){
	var self = this; self.name = "PlaylistController"; // MANDATORY

    this.keyboard = new KeyboardController(self);

    this.data = null;
    this.conditional = new ConditionalController();
    this.synchronizer = false;
    this.renderer = null;

    this.index = -1;
    this.next_index = 0;
    this.playlist = null;
    this.elements = [];
    this.template = false;
    this.list = false;
    this.buildPosition = 0;
    this.rendering = false;
    this.scene = false;
    this.pass = 1;
    this.playlist_id = 0;
    this.udpate_delete_content = null;

    this.contentToBeRendered = -1;
    this.templateToBeRendered = -1;

    this.block_references = [];

    this.timer = false;
    this.has_playing_playlist = false;
		this.change_playlist_interval = 10000;

    this.active = false;

    this.is_jumping = false;

    this.trigger_block = false;

		this.busy = false;

    this.setDataManager = function(DataManagerController){
        self.data = DataManagerController;
    };

    this.setRenderer = function(DisplayController){
        self.renderer = DisplayController;
        if(self.renderer.ui){
            $(self.renderer.ui).on("UserInterfacePlaylistPrevious",self.previous);
            $(self.renderer.ui).on("UserInterfacePlaylistNext",self.next);
        }
    };

    this.load = function(){
        self.playlist = self.data.selectLoop();
        if(self.playlist){
            self.build();
            $(self).trigger("PlaylistControllerReady");
        }else{
            $(self).trigger("PlaylistControllerInvalidPlaylist");
        }
    };

    this.checkPlaylistChange = function(){
			self.log("CheckPlaylistChange ... ");
				clearTimeout(self.timer);
        var playlist = self.data.selectLoop();
        if(playlist){
            if(typeof(playlist.attr('id')) !== "undefined"){
                if(typeof(self.playlist) !== "undefined"){
                    var id = false;
                    try{
                        id = self.playlist.attr('id');
                    }catch(e){
                        id = false;
                    }
                    if(id !== false){
                        if(playlist.attr('id') != self.playlist.attr('id')){
                            self.playlist = null;
                            self.playlist = playlist;
                            self.build();
                            self.log("Has new playlist");
                            self.checknext(1);
                        }
                    }else{
                        self.playlist = null;
                        self.playlist = playlist;
                        self.build();
                        self.log("Has new playlist");
                        self.checknext(1);
                    }
                }else{
                    self.log("Has no playlist");
                    $(self).trigger("PlaylistControllerEmptyPlaylist");
                    self.has_playing_playlist = false;
                }
            }else{
                self.log("Has no playlist");
                $(self).trigger("PlaylistControllerEmptyPlaylist");
                self.has_playing_playlist = false;
            }
        }else{
            self.log("Has no playlist");
            $(self).trigger("PlaylistControllerEmptyPlaylist");
            self.has_playing_playlist = false;
        }
				self.timer = setTimeout(self.checkPlaylistChange,self.change_playlist_interval);
    };

    this.unload = function(){
        self.stop();
        self.renderer.clear();
        for(var i=0;i<self.elements.length;i++){
            self.elements[i] = null;
        }
        self.elements = [];
        self.elements = null;
        //self.data = null;
        self.playlist = null;
        for(var i=0;i<self.list.length;i++){
            self.list[i] = null;
        }
        self.list = null;
        self.renderer = null;
        self.keyboard = null;
    };

    this.update = function(data){
        self.log("<<<<<<< UPDATE >>>>>>");
        self.next_index = self.index;
        if(self.execute(function(){return data;})){
            self.data = null;
            self.data = data;
        }
        self.playlist = null;
        self.udpate_delete_content = self.elements[self.index];
        //var deleteIndex = self.index;
        for(var i=0;i<self.elements.length;i++){
            if(i != self.index){
                self.elements[i] = null;
            }
        }
        var data_conditions = self.data.getConditions();
        if(data_conditions){
            $(self.conditional).off("ConditionTrigger",self.onConditionTrigger);
            $(self.conditional).on("ConditionTrigger",self.onConditionTrigger);
            self.conditional.update(data_conditions);
        }

        self.elements = [];
        self.load();
        self.checknext(1);

        var config = self.data.getConfig();
        var player_mode = config.getMode();
        if(player_mode == 2 || player_mode == 3){
            if(!self.synchronizer){
                self.synchronizer = new SynchronizerController();
								self.conditional.synchronizer = self.synchronizer;
                $(self.synchronizer).on("onSyncChangeMode",self.onSyncModeChanged);
                if(self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
                    $(self.synchronizer).on("on"+self.name+"SyncRecieve",self.onSyncRecieve);
										$(self.synchronizer).on("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
                }else if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
                    $(self.synchronizer).on("onStatusSyncRecieve",self.onStatusSyncRecieve);
                }
            }
            self.synchronizer.update(player_mode,config.getSyncPort(),config.getSyncMachines());
        }
    };

    this.build = function(){
        self.log("<<<<<<< BUILD >>>>>>");
        self.playlist_id = self.playlist.attr("id");
        self.list = self.playlist.find("content_list_item");
        self.list.sort(function(a, b){return (parseInt($(a).attr('position'))-parseInt($(b).attr('position')));});
        self.elements = [];
        for(var i=0;i<self.list.length;i++){
            content_list_item = self.list[i];
            self.buildPosition = self.execute(function(){return $(content_list_item).attr("position");});
            var content_item_id = self.execute(function(){return $(content_list_item).attr("id");});
            var content_item_type = self.execute(function(){return $(content_list_item).attr("type");});
            var content_item_pre_trans = self.execute(function(){return $(content_list_item).attr("pre_transition_id");});
            var content_item_post_trans = self.execute(function(){return $(content_list_item).attr("post_transition_id");});
            var content_item_template_id = self.execute(function(){return $(content_list_item).attr("template_id");});


            if(content_item_id){
                var pre_transition = false;
                var post_transition = false;
                if(content_item_pre_trans){
                    pre_transition = self.data.getArchiveFileItemById(content_item_pre_trans);
                }
                if(content_item_post_trans){
                    post_transition = self.data.getArchiveFileItemById(content_item_post_trans);
                }
                if(content_item_type == "0"){
                    var content = self.data.getArchiveFileItemById(content_item_id);
                    if(content){
                        var position = self.buildPosition;
                        if(pre_transition){
                            self.buildPosition = -1;
                            self.addContent(pre_transition,false);
                        }
                        var template = self.prepareTemplate(content_item_template_id);
                        var conditions = false;
                        if(self.conditional){
                            conditions = self.conditional.createConditionsObject($(content_list_item).find("conditions"));
                        }
                        self.buildPosition = position;
                        self.addContent(content,template,conditions);
                        if(post_transition){
                            self.buildPosition = -2;
                            self.addContent(post_transition,false);
                        }
                    }
                }else if(content_item_type == "1"){
                    var block = self.data.getBlockById(content_item_id);
                    if(block){
                        var position = self.buildPosition;
                        if(pre_transition){
                            self.buildPosition = -1;
                            self.addContent(pre_transition,false);
                        }
                        var template = self.prepareTemplate(content_item_template_id);
                        self.buildPosition = position;
                        self.addBlockContent(block,content_item_template_id);
                        if(post_transition){
                            self.buildPosition = -2;
                            self.addContent(post_transition,false);
                        }
                    }
                }
            }
        }
        if(self.elements.length > 0){
            self.has_playing_playlist = true;
        }

        self.log("Start building aux blocks ... ");
        var aux_blocks = self.data.getBlocks();
        var aux_block_id = 0;
        var block = false;
        for(var i=0;i<aux_blocks.length;i++){
            aux_block_id = self.execute(function(){return $(aux_blocks[i]).attr("id");});
            if(typeof(self.block_references[aux_block_id]) === "undefined"){
                block = self.data.getBlockById(aux_block_id);
                self.log("Add Aux Block Id "+block.getId());
                self.addBlockContent(block,0,false);
            }
        }

        self.log("Build Playlist with "+self.elements.length+" elements");

        var status_for = {
            id:self.playlist_id,
            player:self.data.getConfig().getId(),
            name:self.name
        };
        self.getStatusFile(status_for,function(obj){
            if(obj.xml_timestamp == self.data.getTimestamp()){
                self.index = obj.index;
            }
        })
    };

    this.addContent = function(ContentElement,TemplateElement,Conditions,isElement){
        if(typeof(Conditions) === "undefined"){Conditions = false;}
        if(typeof(isElement) === "undefined"){isElement = true;}
        var addObject = false;

        var displayObjectRef = self.renderer.addDisplayElement(ContentElement);
        if(displayObjectRef){
            var templateObjectRef = self.renderer.addDisplayTemplate(TemplateElement);
            addObject = {content:displayObjectRef,template:templateObjectRef,block:false,position:self.buildPosition,conditions:Conditions}
            if(isElement){
                self.elements.push(addObject);
            }
            if(ContentElement.verify(self.getDate(true).getTime())){
                self.renderer.checkAvailability(displayObjectRef);
            }
        }else{
            self.log("no display object for content : "+ContentElement.getSource());
            self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+3,self.name+": Function addContent() failed : no display object for content : "+ContentElement.getSource());
        }
        return addObject;
    };

    this.addBlockReference = function(BlockElement){
        var id = false;
        if(BlockElement){
            id = self.execute(function(){return BlockElement.getId();});
            //if(typeof(self.block_references[id]) === "undefined"){
            //    self.block_references[id] = BlockElement;
            //}
            self.block_references[id] = BlockElement;
        }
        return id;
    };

    this.getBlockSlotReference = function(BlockReference,isJump){
        var slot = false;
        if(BlockReference){
            if(typeof(self.block_references[BlockReference.id]) !== "undefined"){
                if(isJump){
                    slot = self.block_references[BlockReference.id].getSlot(BlockReference.slot);
                }else{
                    slot = self.block_references[BlockReference.id].updateSlot(BlockReference.slot,self.conditional);
                }

                if(slot.content){
                    var content = self.block_references[BlockReference.id].getContentElement(slot.content);
                    if(content){
                        self.renderer.addDisplayElement(content);
                    }else{
                        slot.template = false;
                    }
                }
                if(slot.template){
                    var template = self.prepareTemplate(slot.template);
                    if(template){
                        slot.template = self.renderer.addDisplayTemplate(template);
                    }else{
                        slot.template = false;
                    }
                //}else{
                //    self.block_references[BlockReference.id].template = false;
                }else{
                    slot.template = false;
                }
            }
        }
        return slot;
    };

    this.prepareTemplate = function(template_id){
        var template = false;

        template = self.data.getTemplateById(template_id);
        if(template){
            template.loadTemplateContentItems(self.data,self.conditional);
        }

        return template;
    };

    this.addBlockContent = function(BlockElement,content_list_item_template_id,isElement){
        if(typeof(isElement) === "undefined"){isElement = true;}
        if(BlockElement.getNumberOfElements() > 0){
            BlockElement.addContentElements(self.data,self.conditional);
            var slots = BlockElement.build();
            for(var i=0;i<slots.length;i++){
                var content = self.data.getArchiveFileItemById(slots[i].content);
                if(content){
                    var template = self.prepareTemplate(slots[i].template);
                    if(!template){
                        template = self.prepareTemplate(content_list_item_template_id);
                    }
                    var conditions = false;
                    // TODO : Add Block Conditions
                    /* Example
                    if(self.conditional){
                        conditions = self.conditional.createConditionsObject($(content_list_item).find("conditions"));
                    }
                    */
                    var addedObject = self.addContent(content,template,conditions,isElement);
                    if(addedObject){
                        var id = self.addBlockReference(BlockElement);
                        addedObject.block = {id:id,slot:i,pos:0};
                    }
                }
            }
        }
    };

    this.start = function(){
				self.OS.busy = false;
        if(!self.timer){
            self.timer = setTimeout(self.checkPlaylistChange,self.change_playlist_interval); // Put a minute 60000
        }
        self.pass = 0;
        self.log("<<<<<<< START >>>>>>");
        $(self.renderer).on("DisplayControllerElementFinish",self.continue);
        $(self.renderer).on("DisplayControllerElementError",self.invalidate);
        $(self.renderer).on("DisplayControllerElementStarted",self.checknext);
        self.main();
        self.active = true;
    };

    this.onSyncRecieve = function(event,action){
				if(action.player_id == ""+self.synchronizer.master_server_id){
					if(action.do == "play"){
	            self.log("<#> Play ! Index = "+self.index);
	            self.main();
	        }else if(action.do == "preload"){
	            self.log("<#> Actual Index = "+self.index+" Want to preload index = "+action.index);
	            if(action.index != self.index){
	                self.log("<#> Index updated to : "+action.index);
	                self.index = parseInt(action.index);
	            }
	            self.log("<#> Checknext for: "+action.index);
	            self.checknext();
					}else if(action.do == "condition"){
							self.log("<#> Set condition from MASTER");
							self.conditional.onNewConditionValue(action.condition,false);  
	        }
				}
        if(!self.active && self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
            self.start();
        }else if(self.active){
            self.log("I'm SLAVE stop autoplaylist playback");
            self.stop();
        }
    };

    this.onStatusSyncRecieve = function(event,action){
        if(!self.active && self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
            self.start();
        }
    };

    this.onSyncModeChanged = function(){
        self.log("Sync Mode Changed to : "+self.synchronizer.using_mode);
        $(self.synchronizer).off("on"+self.name+"SyncRecieve",self.onSyncRecieve);
				$(self.synchronizer).off("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
        $(self.synchronizer).off("onStatusSyncRecieve",self.onStatusSyncRecieve);

        if(self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
            self.stop();
            $(self.synchronizer).on("on"+self.name+"SyncRecieve",self.onSyncRecieve);
						$(self.synchronizer).on("on"+self.conditional.name+"SyncRecieve",self.onSyncRecieve);
        }else if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
            $(self.synchronizer).on("onStatusSyncRecieve",self.onStatusSyncRecieve);
            self.stop();
						self.checknext();
						self.start();
        }
    };

    this.stop = function(){
        clearInterval(self.timer)
        self.active = false;
        self.log("<<<<<<< STOP >>>>>>");
        $(self.renderer).off("DisplayControllerElementFinish");
        $(self.renderer).off("DisplayControllerElementError");
        $(self.renderer).off("DisplayControllerElementStarted");
    };

    this.invalidate = function(){
        self.log("<<<<<<< INVALIDATE >>>>>>");
        self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+6,self.name+": Function invalidate() : renderer reported an error loading content.");
        self.checknext();
        self.main();
    };

    this.main = function(){
        self.index = self.next_index;
        if(self.index == 0){self.pass++;}
        if(self.trigger_block){
            self.trigger_block.render(true);
        }else if(self.scene){
            self.log("<<<<<<< MAIN RENDER INDEX : "+self.next_index+" >>>>>>");


            self.rendering = self.renderer.render_scene(self.scene,self.rendering);
						if(self.synchronizer){
								if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
										self.log("Master Send Broadcast Play !! index = "+self.index);
										self.synchronizer.broadcast({sender:self.name,action:{do:"play",index:self.index,duration:self.scene.content.content.getDuration(),time:self.getDate().getTime(),player_id:self.core_id}});
								}
						}
            self.OS.id_content_now = self.rendering.content.reference;
            self.reportStatus();
            self.log("Rendering : "+self.rendering.content.reference+" ::: "+self.renderer.default_ref);
            if(self.renderer.ui){
                if(self.list.length > 1){
                    self.renderer.ui.printPlaylistInfo(self.elements[self.index],self.list.length);
                }else{
                    self.renderer.ui.unload();
                }
            }
        }else{
            self.log("<<<<<<< MAIN RENDER INDEX : "+self.next_index+" >>>>>>  -- NO SCENE AVAILABLE");
        }
    };

    this.checknext = function(direction,isJump){
        if(typeof(isJump) === "undefined"){isJump = false;}
        self.log("<<<<<<< CHECKNEXT >>>>>>");
        if(self.synchronizer){
            if(self.synchronizer.using_mode == self.synchronizer.MODE_MASTER){
                self.log("Master Send Broadcast Preload !! Actual index :"+self.index);
                self.synchronizer.broadcast({sender:self.name,action:{do:"preload",index:self.index,time:self.getDate().getTime(),player_id:self.core_id}});
            }
        }

        self.contentToBeRendered = self.renderer.getDefaultDisplayReference();
        self.templateToBeRendered = false;
        self.next_index = self.lookfornext(direction,isJump);
        var pos = "-";
        var block_pos = "-";
        if(self.next_index >= 0 && self.has_playing_playlist){
            pos = parseInt(self.elements[self.next_index].position);
            if(pos == -1 ){ pos = "PRE";}
            if(pos == -2 ){ pos = "POST";}
            self.contentToBeRendered = self.elements[self.next_index].content;
            self.templateToBeRendered = self.elements[self.next_index].template;
            if(self.elements[self.next_index].block){
                block_pos = self.elements[self.next_index].block.pos;
            }

            self.lookForConditions(self.elements[self.next_index].conditions);
            var playlist_status = false;
            playlist_status = {
                id: self.playlist_id,
                player:self.data.getConfig().getId(),
                name: self.name,
                index: self.index,
                xml_timestamp: self.data.getTimestamp(),
                pass: self.pass
            };
            self.saveStatusFile(playlist_status);

            // NOT IN USE YET --- HOW TO DEAL WITH SLOTS & MEMORY ¿?
            var block_status = false;
            if(typeof(self.elements[self.next_index]) !== "undefined"){
                if(self.elements[self.next_index].block){
                    var block_id = self.elements[self.next_index].block.id;
                    var block_mode = self.block_references[block_id].getMode();
                    if(block_mode == self.block_references[block_id].BLOCK_TYPE_SEQUENTIAL_MEMORY){
                        block_status = {
                            id: block_id,
                            player:self.data.getConfig().getId(),
                            index: self.elements[self.next_index].block.slot,
                            xml_timestamp: self.data.getTimestamp(),
                            name: self.block_references[block_id].class
                        };
                        self.saveStatusFile(block_status);
                    }
                }
            }
        }

        self.scene = null;
        var die = true;
        if(self.synchronizer){
            if(self.synchronizer.using_mode == self.synchronizer.MODE_SLAVE){
                die = false;
            }
        }
        self.scene = self.renderer.prepare_scene(self.templateToBeRendered,self.contentToBeRendered,die);

        self.log("Next Content Id : "+self.contentToBeRendered
                 +" On Index : "+self.next_index
                 +" For Position : "+pos
                 +" And block Position : "+block_pos);

    };

    this.lookForConditions = function(conditions){
        self.log("<<<<<<< CONDITION CHECK >>>>>>");
        if(conditions){
            var satisfies = self.conditional.checkConditions(conditions);
            if(satisfies >= 0){
                if(conditions[satisfies].action == 0){

                }else if(conditions[satisfies].action == 1){
                    self.setActionContentReplace(conditions[satisfies].value);
                }else if(conditions[satisfies].action == 2){
                    self.setActionFileReplace(conditions[satisfies].value);
                    self.log("Condition replaces content with id : "+self.contentToBeRendered);
                }else if(conditions[satisfies].action == 3){
                    self.setActionTemplateReplace(conditions[satisfies].value);
                    self.log("Condition replaces template with id : "+self.templateToBeRendered);
                }
            }
        }
    };

    this.lookfornext = function(direction,isJump){
        direction = self.execute(function(){
            return direction;
        });
        if(!direction){
            direction = 1;
        }
        isJump = self.execute(function(){
            return isJump;
        });
        var found = false;
        if(self.elements.length > 0){
            var max_count = 0;
            var index = self.index;
            while(!found && max_count < self.elements.length+1){
                if(!found){
                    if(direction == -1){
                        if(index -1 > 0){
                            index--;
                        }else{
                            index = self.elements.length-1;
                        }
                    }else{
                         if(index < self.elements.length-1){
                            index++;
                        }else{
                            index = 0;
                        }
                    }
                }
                self.log("Looking at index : "+index);
                if(self.elements[index].block){
                    if(self.verify_schedule(false,self.elements[index].block)){
                        self.log("Looking inside block ref: "+self.elements[index].block.id);
                        var block_item_found = false;
                        var count_block_items = self.block_references[self.elements[index].block.id].getNumberOfElements();
                        while(!block_item_found && count_block_items > 0){
                            var slot = self.getBlockSlotReference(self.elements[index].block,isJump);
														

                            var DisplayContentElement = self.renderer.getDisplayContentElement(slot.content);
                            if(typeof(DisplayContentElement) !== "undefined"){
                                if(!slot){
                                    self.log("NO block reference");
                                    self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : NO block reference",self.data.getBase64XMLcopy());
                                }else{
                                    self.renderer.checkAvailability(slot.content);
                                    if(DisplayContentElement.available){
																			self.elements[index].content = slot.content;
					                            self.elements[index].block.pos = slot.position;
					                            if(slot.template){
					                                self.elements[index].template = slot.template;
					                            }
																			self.log("Search for playlist position : "+self.elements[index].content+" in pos : "+self.elements[index].position);
																			self.log("Search for block position : "+self.elements[index].block.id+" in pos : "+self.elements[index].block.pos);

                                        if(self.verify_schedule(self.elements[index],false) && self.verify_schedule(false,self.elements[index].block)){
                                            if(DisplayContentElement.content.verify(self.getDate(true).getTime())){
                                                found = true;
                                                block_item_found = true;
                                                break;
                                            }else{
                                                self.log("Block item expired or not active yet ...");
                                                self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : Block item expired or not active yet ",self.data.getBase64XMLcopy());
                                            }
                                        }else{
                                            self.log("Block item not in schedule");
                                            self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : Block item not in schedule",self.data.getBase64XMLcopy());
                                        }
                                    }else{
                                        self.log("Block item not avaiable");
                                    }
                                }
                            }else{
                                self.log("Block unknown error !");
                                self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : block reference undefined",self.data.getBase64XMLcopy());
                            }
                            count_block_items--;
                        }
                    }else{
                        self.log("List item not in schedule : Block Type");
                        self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : List item not in schedule : Block Type",self.data.getBase64XMLcopy());
                    }
                }else{
                    var DisplayContentElement = self.renderer.getDisplayContentElement(self.elements[index].content);
                    if(self.platform != "WEB"){
                        self.log("is available ? "+DisplayContentElement.available);
                        self.renderer.checkAvailability(self.elements[index].content);
                    }
                    if(DisplayContentElement.available){
											self.log("Search for playlist position : "+self.elements[index].content+" in pos : "+self.elements[index].position);
  											if(self.verify_schedule(self.elements[index],false)){
                            if(DisplayContentElement.content.verify(self.getDate(true).getTime())){
                                found = true;
                            }else{
                                self.log("List item expired or not active yet ...");
                                self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : List item expired or not active yet ... ",self.data.getBase64XMLcopy());
                            }
                        }else{
                            self.log("List item not in schedule");
                            self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+4,self.name+": Function lookfornext() failed : List item not in schedule",self.data.getBase64XMLcopy());
                        }
                    }else{
                        self.log("List item not avaiable");
                    }
                }
                max_count++;
            }
        }else{
            self.log("Empty playlist");
            self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+5,self.name+": Function lookfornext() failed : Empty playlist",self.data.getBase64XMLcopy());
        }
        if(!found){index = -1;}
        return index;
    };


    this.reportStatus = function(){
        if(self.rendering){
            var stats_conditions = "";
            if(self.conditional){
                stats_conditions = self.conditional.createConditionsStat(self.data.getStats().getConditionStats());
            }
            self.data.reportStatistics(self.rendering.content.reference,0,stats_conditions);
						self.OS.saveIdContent = self.rendering.content.reference;
            //self.OS.writeFile("admira.status",self.rendering.content.reference+":"+self.pass+":"+self.playlist_id+":"+self.version);

        }
    };

    this.next = function(){
        self.jump(1);
    };

    this.previous = function(){
        self.jump(-1);
    };


    this.continue = function(){
        self.log("<< CONTINUE >>");
        self.main();
    };

    this.getSavedPosition = function(){
        return 1;
    };

    this.jump = function(index){
        if(self.elements !== null){
            if(!self.is_jumping){
                self.is_jumping = true;
                if(index == -1){
                    self.checknext(-1,true);
                }else if(typeof(index) === "undefined"){
                    self.checknext(1,true);
                }
                self.renderer.cancel_all(self.rendering.content.reference);
                self.main();
                self.is_jumping = false;
            }
        }
    };

    this.verify_schedule = function(element,block){
        var start = 0;
        var end = 0;
        var content_block_item =false;
        if(block){
            content_block_item = $(self.data.reader.loops()).find("blocks[id='"+block.id+"']").find("content_block_item[position='"+block.pos+"']");
            start = parseInt($(content_block_item).attr('startHour'));
            end = parseInt($(content_block_item).attr('endHour'));
        }else if(element){
            content_list_item = self.playlist.find("content_list_item[position='"+element.position+"']");
            start = parseInt($(content_list_item).attr('startHour'));
            end = parseInt($(content_list_item).attr('endHour'));
        }
        if(end == 0){end = 1440;}

        if(isNaN(start) && isNaN(end)){ return true; }
        var date = self.getDate();
        var hours = 0;
        var minutes = 0;
        if(self.server_time_activated){
            hours = date.getUTCHours();
            minutes = date.getUTCMinutes();
        }else{
            hours = date.getHours();
            minutes = date.getMinutes();
        }
        var total_minutes = (hours*60) + minutes;

        self.log("Schedule check : "+start+" < [ "+total_minutes+" ] > "+end);

        if(start <= total_minutes && end >= total_minutes){
            hours = null;
            minutes = null;
            date = null;
            start = null;
            end = null;

            return true;
        }
        return false;
    };

    this.keyUp = function(keyCode,shifted){
    }

    this.keyDown = function(keyCode,shifted){
        if(keyCode == 37) {
            self.jump(-1);
        }
        if(keyCode == 39) {
           self.jump();
        }

    }

    this.keyPress = function(keyCode,shifted){

    }

    this.onConditionTrigger = function(e,interruption,action,action_value){
        self.log("Prepare Trigger Action : "+action+" Value : "+action_value+" Interrupts : "+interruption);
        var hasTrigger = false;
        var action = parseInt(action);
				var interrupts = Boolean(parseInt(interruption));
        switch(action){
            case 1:
                hasTrigger = self.setActionContentReplace(action_value);
								if(self.rendering && !self.trigger_block && interrupts){
									self.renderer.cancel_all(self.rendering.content.reference);
								}
            break;
            case 2:
                hasTrigger = self.setActionFileReplace(action_value);
								if(hasTrigger){
									if(self.rendering && interrupts){
										self.renderer.cancel_all(self.rendering.content.reference);
									}
									self.scene = self.renderer.prepare_scene(self.templateToBeRendered,self.contentToBeRendered);
								}
            break;
            case 3:
                hasTrigger = self.setActionTemplateReplace(action_value);
								if(hasTrigger){
									if(self.rendering && interrupts){
										self.renderer.cancel_all(self.rendering.content.reference);
									}
									self.scene = self.renderer.prepare_scene(self.templateToBeRendered,self.contentToBeRendered);
								}
            break;
            case 4:
                hasTrigger = self.setActionPlaylistPositionReplace(action_value);
            break;
            default:
                self.log("Trigger Action Unavailable : "+action);
            break;
        };
        if(hasTrigger){
            if(interrupts == 1){
                self.main();
            }
        }
    };

    this.setActionFileReplace = function(value){
        var trigger = false;
        var ContentElement = self.data.getArchiveFileItemById(value);
        if(ContentElement){
            id = self.renderer.addDisplayElement(ContentElement);
            if(id){
                if(ContentElement.verify(self.getDate(true).getTime())){
                    self.renderer.checkAvailability(ContentElement.getId());
                    self.contentToBeRendered = ContentElement.getId();
                    self.templateToBeRendered = false;
                    trigger = true;
                }
            }
        }
        return trigger;
    };

    this.setActionTemplateReplace = function(value){
        var trigger = false;
        var template = self.prepareTemplate(value);
        if(template){
            id = self.renderer.addDisplayTemplate(template);
            self.templateToBeRendered = id;
            trigger = true;
        }
        return trigger;
    };

    this.setActionPlaylistPositionReplace = function(value){
        // TODO
    };

    this.setActionContentReplace = function(value){
        var trigger = false;

        var element_index = self.elements.map(function(e){
            if(e.block){
                return e.block.id;
            }else{
                return e.content;
            }
        }).indexOf(parseInt(value));

        if(element_index != -1){
            if(self.elements[element_index].block){
                var slot = self.block_references[self.elements[element_index].block.id].getSlot();
                self.contentToBeRendered = slot.content;
                self.templateToBeRendered = slot.template;
            }else{
                self.contentToBeRendered = self.elements[element_index].content;
                self.templateToBeRendered = self.elements[element_index].template;
            }
            trigger = true;
        }else{
            var block_id = parseInt(value);
            if(typeof(self.block_references[block_id]) !== "undefined"){
                if(self.trigger_block){
                    self.trigger_block.unload();
										self.trigger_block = null;
                    self.trigger_block = false;
                }
                self.stop();
                //self.block_references[block_id].position = -1;
								try{
									self.trigger_block = new DisplayBlock(self.block_references[block_id],self.renderer,self.conditional);
	                self.trigger_block.load(true);
	                $(self.trigger_block).one("DisplayBlockFinished",self.onTriggeredBlockFinished);
	                trigger = true;
								}catch(e){
									self.log(": DisplayBlock not available --- please update the player");
									self.notifyError(self.ERROR['PLAYLIST_CONTROLLER']+7,self.name+": DisplayBlock not available --- please update the player");
								}
            }
        }
        return trigger;
    };

    this.onTriggeredBlockFinished = function(e){
        self.trigger_block.unload();
        self.trigger_block = null;
        self.trigger_block = false;
        self.checknext();
        self.start();
    };

}
PlaylistController.prototype = new SystemController();
