function SynchronizerController(){
	var self = this; self.name = "SynchronizerController"; // MANDATORY

    this.ACTION_STATUS = 0;
    this.ACTION_PLAY = 1;
    this.ACTION_PRELOAD = 2;
    
    this.MODE_NORMAL = 0
    this.MODE_MASTER = 2;
    this.MODE_SLAVE = 3;
    
    this.api_connector = new ApiConnector();
    this.server_timer = 0;
    this.scan_timer = 0;
    this.server_interval = 1000; 
    this.scan_interval = 15000;
    this.mode = this.MODE_NORMAL;
    this.using_mode = this.MODE_NORMAL;
    this.ip = "0.0.0.0";
    this.subnet = "0.0.0.0";
    this.port = 41414;
    this.servers = [];
    this.times = [];
    this.highest_id = 0;
    this.master_server_id = 0;
    
    this.clock = 0;
		this.searching = false;
		
		this.connections = [];
		for(var i=1;i<255;i++){this.connections[i] = {"ip":"","checked":true,"player_id":0,"socket":false,"time":0,"alive":false};}
		this.check_timer = 0;
		this.scanning = false;

    this.update = function(sync_mode,sync_port,sync_machines){
        clearTimeout(self.server_timer);
        clearTimeout(self.scan_timer);
        if(typeof(sync_mode) !== "undefined"){
            self.mode = sync_mode;
            if(self.using_mode != sync_mode){
                self.using_mode = self.MODE_MASTER;//sync_mode;
                //$(self).trigger("onSyncChangeMode");
            }
        }
        if(typeof(sync_port) !== "undefined"){
            if(sync_port > 49152 && sync_port < 65535){
                self.port = sync_port;
            }
        }
        self.master_last_timestamp = self.getDate().getTime();
        
        if(self.mode == self.MODE_MASTER || self.mode == self.MODE_SLAVE){
						self.checkServerStatus();
						self.OS.findSyncIp(self.onIpFound);
        }  
				self.check_members();
    };
		
		this.onIpFound = function(ip){
			self.log("My Ip : "+self.ip);
			self.log("onIpFound : "+ip);
			if(ip != self.ip){
				self.log("onIpFound : Setting IP");
				self.ip = ip;
				self.log("onIpFound : My new IP "+self.ip);
				self.subnet = self.ip.substr(0,self.ip.lastIndexOf(".")+1);   
				self.log("onIpFound : My new subnet "+self.subnet);
				var index = self.ip.substr(self.ip.lastIndexOf(".")+1,self.ip.length); 
				self.log("onIpFound : My new index "+index);
				self.servers[index] = {"ip":self.ip,"checked":true,"player_id":self.core_id,"socket":false,"time":0,"alive":true};
				self.lookup();
			}else if(ip == "0.0.0.0"){
				self.log("onIpFound : keep looking ... retry");
				setTimeout(function(){
					self.log("onIpFound : retrying ... ");
					self.OS.findSyncIp(self.onIpFound);
				},1000);
			}			
		};
    
    this.checkServerStatus = function(){
        if(self.using_mode == self.MODE_MASTER && self.mode == self.MODE_MASTER){
            self.log("<<<<<<< USING SYNC MODE MASTER with IP: "+self.ip+" >>>>>>");
        }else if(self.using_mode == self.MODE_MASTER && self.mode == self.MODE_SLAVE){
            self.log("<<<<<<< USING SYNC MODE FAKE MASTER with IP: "+self.ip+" >>>>>>");
        }else{
            self.log("<<<<<<< USING SYNC MODE SLAVE with IP: "+self.ip+" - Master Player ID is : "+self.master_server_id);
        }
        clearTimeout(self.server_timer);
				self.OS.findSyncIp(self.onIpFound);
				self.server_timer = setTimeout(self.checkServerStatus,self.server_interval);     
        if(typeof(self.OS.socketServerStart) !== "undefined"){
            if(!self.OS.websocket_server){
                self.log("Starting Websocket Server ...");
                self.OS.socketServerStart(self.port,self.onServerSocketOpen,self.onServerRecieveMessage,self.onServerSocketClose);
            }else{
                self.broadcast({
                    sender:self.name,
                    action:{
                        do:"status",
                        default_mode: self.mode,
                        using_mode: self.using_mode,
                        player_id : self.core_id,
                        time:new Date().getTime()
                    }
                },true);
            }
        }else{
            self.log("Platform has no Websocket Server Support");
            self.notifyError(self.ERROR['SYNCHRONIZER_CONTROLLER']+1,self.name+": WARNING !! Trying to use as SyncMaster ! : Platform has NO Websocket Server Support, can't become MASTER");   
        }
        self.checkMasterAlive();
    };
		
		this.lookup = function(){
				clearTimeout(self.check_timer);
				if(self.check_scan_result()){
					self.log("All connections are checked ... ");				
					self.scan_timer = setTimeout(self.scan,15000);
				}else{
					if(!self.scanning){
						self.log("Start network scan ... ");
						self.scan();
					}else{
						self.log("Scanning ...")
					}
					self.check_timer = setTimeout(self.lookup,3000);
				}
		};
		
		this.check_scan_result = function(){
			var all_checked = true;
			for(var i=1;i<self.connections.length;i++){
				if(self.subnet+i != self.ip){
					if(!self.connections[i].checked){
						all_checked = false;
					}
					if(self.connections[i].socket){
						self.log("Saved Server on : "+self.connections[i].ip);
						self.connect_socket_client(i);
					}
				}
			}
			return all_checked;
		};
		
		this.reset_scanner = function(){
			self.log("Reset Scanner");
			for(var i=1;i<self.connections.length;i++){
				if(self.subnet+i != self.ip){
					if(self.connections[i].ip == ""){
						self.connections[i].ip = self.subnet+i;
					}
					if(!self.connections[i].socket){
						self.connections[i].checked = false;
					}
				}
			}
		};
		
		this.scan = function(){
			self.scanning = true;
			clearTimeout(self.scan_timer);
			self.check_timer = setTimeout(self.lookup,2000);
			self.reset_scanner();
			self.log("Create connections");
			for(var i = 1; i<255;i++){
				if(self.subnet+i != self.ip){
					if(!self.connections[i].checked && !self.connections[i].socket){
						try{
							//self.log("Trying to connect to = ws://"+self.subnet+i+":"+self.port+"/");
							var connection = new WebSocket("ws://"+self.subnet+i+":"+self.port+"/");
						 connection.onopen = function(e){
								 var server_index = self.getServerIndex(e.currentTarget.url);
								 if(typeof(self.servers[server_index]) === "undefined"){
									 self.connections[server_index].ip = self.subnet+server_index; 
									 self.connections[server_index].socket = true; 
									 self.connections[server_index].checked = true;
									 e.currentTarget.close();
								 }
						 };
						 connection.onclose = function(e){
							 var server_index = self.getServerIndex(e.currentTarget.url);
							 self.connections[server_index].checked = true;
							 e.currentTarget.close();
						 };
						 connection.onerror = function(e){
							 var server_index = self.getServerIndex(e.currentTarget.url);
							 self.connections[server_index].checked = true;
							 e.currentTarget.close();
						 };
						}catch(e){
							self.connections[i].checked = true;						
						}
					}
				}
			}
		};
		
		this.connect_socket_client = function(index){
			try{
				if(typeof(self.servers[index]) == "undefined"){
						self.servers[index] = self.connections[index];
						self.servers[index].socket = new WebSocket("ws://"+self.subnet+index+":"+self.port+"/");
						self.servers[index].socket.onopen = self.onClientOpen;
						self.servers[index].socket.onmessage = self.onClientMessageRecieve;
				}else if(self.servers[index].socket.readyState >= 2){ //|| !self.servers[index].alive){
					self.servers[index].socket.close();
					self.servers[index].socket = null;
					self.servers[index].socket = new WebSocket("ws://"+self.subnet+index+":"+self.port+"/");
					self.servers[index].socket.onopen = self.onClientOpen;
					self.servers[index].socket.onmessage = self.onClientMessageRecieve;
					self.servers[index].socket.onclose = self.onClientClose; 
					self.servers[index].socket.onerror = self.onClientError; 
				}
			}catch(e){
				self.log("connect_socket_client socket.io error");		
			}
		};
		
    this.broadcast = function(msg,force){
        if(typeof(force) === "undefined"){force = false;}
        if(self.using_mode == self.MODE_MASTER || force){
            self.OS.socketServerBroadcast(msg);
        }
    };
    
    this.checkActualMode = function(action){
        if(self.using_mode == self.MODE_MASTER){
            // Check other MASTERs
            if(action.default_mode == self.MODE_MASTER && action.using_mode == self.MODE_MASTER){
                // Another MASTER found -> Check Highest Player Id
                if(self.mode == self.MODE_MASTER){
                    var remote_id = parseInt(action.player_id);
                    self.log("Another MASTER found -> Check Highest Player Id - Remote ID: "+remote_id);
                    if(remote_id > self.highest_id){
                        self.highest_id = remote_id;
                    }
                    self.log("My ID : "+self.core_id+" Highest ID : "+self.highest_id);
                    if(self.highest_id > self.core_id){
                        if(self.using_mode != self.MODE_SLAVE){
                            self.using_mode = self.MODE_SLAVE;
                            $(self).trigger("onSyncChangeMode");
                        }
                        self.master_server_id = self.highest_id;
                        self.master_last_timestamp = self.getDate().getTime();
                    }else{
                        if(self.using_mode != self.MODE_MASTER){
                            self.using_mode = self.MODE_MASTER;
                            $(self).trigger("onSyncChangeMode");
                        }
                    }
                }else{
                    self.master_server_id = 0;
                    if(self.using_mode != self.MODE_SLAVE){
                        self.using_mode = self.MODE_SLAVE;
                        $(self).trigger("onSyncChangeMode");
                    }
                    self.master_last_timestamp = self.getDate().getTime();
                }
            }else if(self.mode == self.MODE_SLAVE && action.default_mode == self.MODE_SLAVE && action.using_mode == self.MODE_MASTER){
                var remote_id = parseInt(action.player_id);
                self.log("Another FAKE MASTER found -> Check Highest Player - Remote ID: "+remote_id);
                if(remote_id > self.highest_id){
                    self.highest_id = remote_id;
                }
                self.log("My ID : "+self.core_id+" Highest ID : "+self.highest_id);
                if(self.highest_id > self.core_id){
                    if(self.using_mode != self.MODE_SLAVE){
                        self.using_mode = self.MODE_SLAVE;
                        $(self).trigger("onSyncChangeMode");
                    }
                    self.master_server_id = self.highest_id;
                    self.master_last_timestamp = self.getDate().getTime();
                }    
            }
        }else if(self.using_mode == self.MODE_SLAVE && action.using_mode == self.MODE_MASTER){
            // MASTER Server Found.
            if(parseInt(action.player_id) != self.core_id){
                self.master_server_id = parseInt(action.player_id);          
            }
            self.master_last_timestamp = self.getDate().getTime();            
        }
        
    };
           
    this.checkMasterAlive = function(action){
        if(self.using_mode == self.MODE_SLAVE){
            var inactive_milliseconds = self.getDate().getTime() - self.master_last_timestamp;
            if(inactive_milliseconds > 20000){
                if(self.master_server_id > 0){
                    self.log("Master connection lost !!!");
                    self.master_server_id = 0;
                }else{
                    self.log("No Master found ... try to become a MASTER");
                    if(self.using_mode != self.MODE_MASTER){
												//self.servers = [];
                        self.using_mode = self.MODE_MASTER;
                        $(self).trigger("onSyncChangeMode");
                    }
                }
            }
        }
    };
    
    this.onClientMessageRecieve = function(e){
				var server_index = self.getServerIndex(e.currentTarget.url);
        var data = JSON.parse(e.data);
        if(typeof(data) === "object"){
            if(data.hasOwnProperty("sender")){
                if(data.sender == self.name){
                    self.checkActualMode(data.action);
                    self.times[server_index] = data.action.time;
										if(typeof(self.servers[server_index]) !== "undefined"){
											self.servers[server_index].player_id = data.action.player_id;
											self.servers[server_index].time = data.action.time;
										}
                    $(self).trigger("onStatusSyncRecieve",[data.action]);
                }else{
                    $(self).trigger("on"+data.sender+"SyncRecieve",[data.action]);
                }
            }
        }
    };
    
    this.onClientOpen = function(e){
				var server_index = self.getServerIndex(e.currentTarget.url);
        self.log("onClientOpen : Websocket Connected !! "+self.subnet+server_index);
    };
    
    this.onClientClose = function(e){
				var server_index = self.getServerIndex(e.currentTarget.url);
        self.log("onClientClose : Websocket Disconnected !! "+self.subnet+server_index);
    };
    
    this.onClientError = function(e){
				var server_index = self.getServerIndex(e.currentTarget.url);
				self.log("onClientError : Websocket Error !! "+self.subnet+server_index);
    };
		
		this.onServerRecieveMessage = function(msg){
			self.log("onServerRecieveMessage : Recieved from client");
		};
		
		this.onServerSocketOpen = function(ip){
			self.log("onServerSocketOpen : opened a connection  ");
		};
		
		this.onServerSocketClose = function(ip){
			self.log("onServerSocketClose : closed a connection");
		};
		
		
    this.getAverageDelay = function(){
        var timestamp = self.getDate().getTime();
        var sum = 0;
        var count = 0;
        for(var time in self.times){
            sum+= (timestamp - self.times[time]);
            count++;
        }
        if(count > 0){
            sum = parseInt(sum /count);
        }else{
            sum = 0;
        }
        return sum*-1;
    };
    
    this.stop = function(){
        clearTimeout(self.server_timer);
        clearTimeout(self.scan_timer);
    };
    
    this.unload = function(){
        clearTimeout(self.server_timer);
        clearTimeout(self.scan_timer);
        self.api_connector = null;  
    };
    
		

    
    this.getServerIndex = function(url){
        url = url.replace("http://","");
        url = url.replace(":"+self.port,"");
        url = url.replace("/","");
        return parseInt(url.substring(url.lastIndexOf('.')+1,url.length));
    };
		
		this.check_members = function(){
			clearTimeout(self.members_timer);
			//self.log("Check Members ...");
			var now = new Date().getTime();		
			for(var i in self.servers){
				if(now - self.servers[i].time < 60000){
					self.servers[i].alive = true;
				}else{
					self.servers[i].alive = false;
				}
			}
			self.update_content_api_info(self.servers);
			self.members_timer = setTimeout(self.check_members,1500);
		};
		
		this.update_content_api_info = function(connections){
			var info = {
				ip:self.ip,
				port:self.port,
				mode:self.mode,
				player_id:self.core_id,
				using_mode:self.using_mode,
				members: []
			};
			for(var c in connections){
				if(typeof(connections[c].ip) !== "undefined"){
					info.members.push({ip:connections[c].ip,player_id:connections[c].player_id,alive:connections[c].alive});
				}
			}
			if(self.content_api){
				self.content_api.updateInfo(self.name,info);
				self.content_api.broadcastApiContentEvent(self.content_api.API_PLAYER_INFO,self.content_api.info);
			}
		};
}	
SynchronizerController.prototype = new SystemController();
    
