function DisplayContentElement(){
    var self = this; self.name = "DisplayContentElement"; // MANDATORY

    this.reference = 0;
    this.content = false;

    this.controller = [];

    this.available = false;
    this.type = false;
    this.layer = 0;

    this.active_switcher = 0;

    this.create = function(ContentElement){
        self.update(ContentElement);
        self.createDisplayElement();
    };

    this.update = function(ContentElement){
        if(typeof(ContentElement) != "undefined"){
            if(ContentElement){
                if(self.content){
                    self.content = null;
                    self.content = false;
                }
                self.content = ContentElement;
                ContentElement.path = self.getPath();
                if(self.controller.length == 2){
                    self.controller[0].update(ContentElement);
                    self.controller[1].update(ContentElement);
                }
            }
        }
    };

    this.setControllerReferences = function(ref,layer,type){
        self.reference = ref;
        self.layer = layer;
        self.type = type;
        if(self.controller.length == 2){
            self.controller[0].reference = ref;
            self.controller[1].reference = ref;
            self.controller[0].layer = layer;
            self.controller[1].layer = layer;
            self.controller[0].type = type;
            self.controller[1].type = type;
        }
    };

    this.createDisplayElement = function(){
        var source = self.execute(function(){return self.content.getSource();});
        if(source){
            var extension = source.substring(source.lastIndexOf('.')+1,source.length);
            if(self.content.force_http_source){ extension = "html"; }
            switch(extension){
                case "url" : case "youtube" :
                    self.type = self.VIEWER_TYPE_IFRAME;
                    self.controller[0] = new DisplayWebUrlElement(self.content);
                    self.controller[1] = new DisplayWebUrlElement(self.content);
                break;
                case "html" : case "pdf" :
                    self.type = self.VIEWER_TYPE_IFRAME;
                    self.controller[0] = new DisplayWebElement(self.content);
                    self.controller[1] = new DisplayWebElement(self.content);
                break;
                case "swf" :
                    self.type = self.VIEWER_TYPE_SWF;
                    self.controller[0] = new DisplayFlashElement(self.content);
                    self.controller[1] = new DisplayFlashElement(self.content);
                break;
                case "svg" : case "jpg" : case "jpeg" : case "png" : case "gif" : case "mjpeg":
                    self.type = self.VIEWER_TYPE_IMAGE;
                    self.controller[0] = new DisplayImageElement(self.content);
                    self.controller[1] = new DisplayImageElement(self.content);
                break;
                case "mov" : case "mp4" : case "webm" : case "3gp" : case "stream":
                    self.type = self.VIEWER_TYPE_VIDEO;
                    self.controller[0] = new DisplayVideoElement(self.content);
                    self.controller[1] = new DisplayVideoElement(self.content);
                break;
                default:
                 self.notifyError(self.ERROR['DISPLAY_CONTENT_ELEMENT']+1,self.name+": Function createDisplayElement() failed : File Extension not supported : "+source);
                break;
            }
        }
    };

    this.preload = function(switcher,html,viewer,die,time_to_die){
        self.log("PRELOAD "+self.controller[switcher].reference+" On "+html);
        $(self.controller[switcher]).off('DisplayElementError',self.onDisplayElementError);
        $(self.controller[switcher]).off('DisplayElementLoaded',self.onDisplayElementLoaded);
        $(self.controller[switcher]).one('DisplayElementError',self.onDisplayElementError);
        $(self.controller[switcher]).one('DisplayElementLoaded',self.onDisplayElementLoaded);
        self.controller[switcher].modifyViewer(viewer.x,viewer.y,viewer.w,viewer.h,viewer.z);
        self.controller[switcher].tag = html;
        self.controller[switcher].die = die;
        self.controller[switcher].time_to_die = time_to_die;
        self.controller[switcher].load();
    };

    this.cancel_preload = function(switcher){
        self.log("PRELOAD : cancel");
        //self.controller[switcher].disable();
        $(self.controller[switcher]).off('DisplayElementError',self.onDisplayElementError);
        $(self.controller[switcher]).off('DisplayElementLoaded',self.onDisplayElementLoaded);
    };

    this.render = function(switcher,viewer,ui){
        self.log("RENDER : Normal");
        $(self.controller[switcher]).one('DisplayElementPlay',self.onDisplayElementPlaying);
        self.controller[switcher].modifyViewer(viewer.x,viewer.y,viewer.w,viewer.h,viewer.z);
        self.controller[switcher].setViewer();
        self.controller[switcher].play();
        self.controller[switcher].connect(ui);
    };

    this.direct_render = function(switcher,html,viewer,die,time_to_die){
        self.controller[switcher].tag = html;
        $(self.controller[switcher]).off('DisplayElementLoaded',self.onDisplayElementLoaded);
        $(self.controller[switcher]).one('DisplayElementLoaded',self.onDisplayElementLoadedDirect);
        $(self.controller[switcher]).one('DisplayElementError',self.onDisplayElementError);
        //self.getBenchmark("Direct Render Events");
        self.controller[switcher].modifyViewer(viewer.x,viewer.y,viewer.w,viewer.h,viewer.z);
        self.controller[switcher].load();
        //self.getBenchmark("Direct Render Load");
        self.controller[switcher].die = die;
        self.controller[switcher].time_to_die = time_to_die;
        //self.getBenchmark("Direct Modify Viewer");
    };

    this.onDisplayElementLoadedDirect = function(event){
        //self.getBenchmark("Direct Load Complete");
        event.stopImmediatePropagation();
        $(event.currentTarget).one('DisplayElementPlay',self.onDisplayElementPlaying);
        //self.getBenchmark("Direct Play Events");
        event.currentTarget.play();
        //self.getBenchmark("Direct Play !");
        $(event.currentTarget).off('DisplayElementLoaded',self.onDisplayElementLoaded);
        $(event.currentTarget).off('DisplayElementError',self.onDisplayElementError);
        //self.getBenchmark("Direct Remove Load Events");
    };

    this.cancel = function(switcher,force){
        if(typeof(self.controller[switcher]) !== "undefined"){
            $(self.controller[switcher]).off('DisplayElementLoaded',self.onDisplayElementLoaded);
            $(self.controller[switcher]).off('DisplayElementPlay',self.onDisplayElementPlaying);
            $(self.controller[switcher]).off('DisplayElementError',self.onDisplayElementError);
            $(self.controller[switcher]).off('DisplayElementFinish',self.onDisplayElementFinish);
            if(force){
              self.controller[switcher].disconnect();
              self.controller[switcher].disable();
              self.controller[switcher].loaded = false;
              self.controller[switcher].destroy(0);
            }else{
              self.controller[switcher].timeout();
            }
        }
    };

    this.onDisplayElementLoaded = function(event){
        $("#"+event.currentTarget.tag).css("z-index","0");
        event.stopImmediatePropagation();
        self.log("Loaded "+event.currentTarget.reference+" On "+event.currentTarget.tag);
        $(event.currentTarget).off('DisplayElementError',self.onDisplayElementError);
        $(event.currentTarget).off('DisplayElementLoaded',self.onDisplayElementLoaded);
        $(self).trigger("DisplayContentElementLoaded");
    };

     this.onDisplayElementPlaying = function(event){
        event.stopImmediatePropagation();
        event.currentTarget.setViewer();
        //self.getBenchmark("Direct Set Viewer");
        self.log("Playing "+event.currentTarget.reference+" On "+event.currentTarget.tag);
        $(event.currentTarget).off('DisplayElementPlay',self.onDisplayElementPlaying);
        $(event.currentTarget).one('DisplayElementFinish',self.onDisplayElementFinish);
        //self.getBenchmark("Direct Play Remove Events");
        $(self).trigger("DisplayContentElementPlay");
    };

    this.onDisplayElementError = function(event){
        event.stopImmediatePropagation();
        self.log("Error "+event.currentTarget.reference+" On "+event.currentTarget.tag);
        $(event.currentTarget).off('DisplayElementError',self.onDisplayElementError);
        $(event.currentTarget).off('DisplayElementLoaded',self.onDisplayElementLoaded);
        event.currentTarget.available = false;
        event.currentTarget.disconnect(self.ui);
        //event.currentTarget.destroy(0);
        $(self).trigger("DisplayContentElementError");
        self.notifyError(self.ERROR['DISPLAY_CONTENT_ELEMENT']+2,self.name+": Function onDisplayElementError() failed");
    };

    this.onDisplayElementFinish = function(event){
       event.stopImmediatePropagation();
        self.log("Finished "+event.currentTarget.reference+" On "+event.currentTarget.tag);
        $(event.currentTarget).off('DisplayElementFinish',self.onDisplayElementFinish);
        $(event.currentTarget).off('DisplayElementError',self.onDisplayElementError);
        $(event.currentTarget).off('DisplayElementLoaded',self.onDisplayElementLoaded);
        if(event.currentTarget.die){
            $("#"+event.currentTarget.tag).css("z-index","0");
            //event.currentTarget.destroy(event.currentTarget.time_to_die);
            event.currentTarget.loaded = false;
        }
        event.currentTarget.disconnect();
        $(self).trigger("DisplayContentElementFinish");
    };

    this.unload = function(){
        self.content = null;
        if(self.controller.length == 2){
            self.controller[0].destroy(0);
            self.controller[1].destroy(0);
            self.controller[0] = null;
            self.controller[1] = null;
            self.controller = null;
        }
    };

    this.getPath = function(){
        var path = "";
        if(self.trim_path){
            var file = self.content.getSource();
            file = file.substring(file.lastIndexOf("/")+1,file.length);
            path = self.OS.rootDir+self.ROUTES['CONTENT'].path+file;
        }else{
            path = self.OS.rootDir+self.ROUTES['CONTENT'].path+self.content.getSource();
        }
        if(self.content.relative_path){
            path = self.content.getSource();
        }
        if(self.platform == "CHROMEOS"){
          var protocol = path.substr(0,4);
          if(protocol != "http"){
            path = self.OS.fs.root.toURL()+path;
          }
        }
        return path;
    };

}
DisplayContentElement.prototype = new SystemController();
