function ConditionsElement(types,triggers){
    var self = this;
    this.class = "ConditionsElement"; // MANDATORY
	this.condition_types = types;
	this.condition_triggers = triggers;
    
    this.types = [];
    this.triggers = [];
    this.involved_conditions = [];
	
    this.getTypes = function(reload){
        if(typeof(reload) === "undefined"){reload = false;}
        if(reload){
            self.types = null;
            self.types = [];
        }
        if(self.types.length == 0){
            var find_types = this.condition_types.find("condition_type");
            for(var i=0;i<find_types.length;i++){
                self.types.push({
                    'id': find_types.eq(i).attr('id'),
                    'filename':  find_types.eq(i).attr('data_file'),
                    'mdate': 0,
                    'count_all': find_types.eq(i).attr('count_all'),
                    'last_value': ""
                });
            } 
        }
        return self.types;
    };
    
    this.getTriggers = function(reload){
        if(typeof(reload) === "undefined"){reload = false;}
        if(reload){
            self.triggers = null;
            self.triggers = [];
        }
        if(self.triggers.length == 0){
            //var affected_types = [];
            var find_triggers = this.condition_triggers;
            for(var h=0;h<find_triggers.length;h++){
                var trigger_id = find_triggers.eq(h).attr('trigger_id');
                var conditions = [];
                var find_conditions = this.condition_triggers.find("conditions");
                for(var i=0;i<find_conditions.length;i++){
                    var clauses = [];
                    var find_clauses = find_conditions.eq(i).find('condition');
                    for(var j=0;j<find_clauses.length;j++){
                        var id = find_clauses.eq(j).attr('condition_type_id');
                        var affected_index = self.involved_conditions.map(function(e){return e.condition;}).indexOf(id);
                        if(affected_index == -1){
                            self.involved_conditions.push({'condition':id,'affects':trigger_id});
                        }
                        clauses.push({
                            'id': id,
                            'operator':  find_clauses.eq(j).attr('operator'),
                            'satisfies': find_clauses.eq(j).attr('value')
                        });
                    }
                    var result = find_conditions.eq(i).find('result');

                    conditions.push({
                        'clauses': clauses,
                        'action': result.attr('action_id'),
                        'action_name': result.attr('action'),
                        'cancelable': result.attr('action'),
                        'value': result.text()
                    });
                }  
                
                self.triggers[trigger_id] = {
                    'id': trigger_id,
                    'interruption':  find_triggers.eq(h).attr('interruption'),
                    'interval': find_triggers.eq(h).attr('interval'),
                    'conditions':conditions,
                    'busy':false
                };
            }  
        }
        return self.triggers;
    };
    
    this.getInvolved = function(id){
        return self.involved_conditions.map(function(e){
            if(e.condition == id){
                return e.affects;
            }else{
                return false;
            }
        });
    };
    
    this.getConditionsFromElement = function(find_conditions){
        var conditions = [];
        for(var i=0;i<find_conditions.length;i++){
            var clauses = [];
            var find_clauses = find_conditions.eq(i).find('condition');
            for(var j=0;j<find_clauses.length;j++){
                var id = find_clauses.eq(j).attr('condition_type_id');
                clauses.push({
                    'id': id,
                    'operator':  find_clauses.eq(j).attr('operator'),
                    'satisfies': find_clauses.eq(j).attr('value')
                });
            }
            var result = find_conditions.eq(i).find('result');

            conditions.push({
                'clauses': clauses,
                'action': result.attr('action_id'),
                'action_name': result.attr('action'),
                'cancelable': result.attr('action'),
                'value': result.text()
            });
        }  
        return conditions;
    };
}
