var player = false;
var transfer = false;
var inactivityTimer = 0;
var manager = false;
var conditional = false;
var logger_visible = false;

var geo_watch_id = false;

var status_bar_timer = false;

document.addEventListener('deviceready', function(){
    window.plugins.insomnia.keepAwake();
    $(document).ready(function(){
        if(!player){
            player = new PlayerController();
            //player.activateLogger(true);
            $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
            player.init();
        }
    });
}, false);


function status_bar_hide(){
  clearTimeout(status_bar_hide);
  player.log("Hide Status Bar ...");
  StatusBar.hide();
  status_bar_timer = setTimeout(status_bar_hide,3000);
}

function onPlayerDataLoaded(){
    if(player.platform == "ANDROID"){
        cordova.plugins.backgroundMode.enable();
    }
    if(!transfer){
        transfer = new TransferService();
        transfer.init(player.version);
        transfer.setLogger(player.logger);
    }
    transfer.update(player.timestamp,player.dataManager.getArchiveFiles());
    transfer.activateLogger(player.debug);
    if(!manager){
        manager = new ManagerService();
        manager.init();
        manager.setLogger(player.logger);
    }
    manager.update(player.config.getScheduleConfig());
    manager.activateLogger(player.debug);

    //Kiosk.setKioskEnabled(player.config.getAlwaysOnTop());
    if(player.playlist.conditional){
        if(!conditional){
            conditional = new ConditionalService();
            conditional.init(player.playlist.conditional.onNewConditionValue);
        }
        conditional.update(player.playlist.conditional.types);

        // Condition Agents Activate
        activateConditionalAgents(true);
    }else{
        if(conditional){
            conditional.unload();
            conditional = null;
            conditional = false;
        }
        // Condition Agents Deactivate
        activateConditionalAgents(false);
    }
}

document.addEventListener("touchend", onTouchScreen, false);

function onTouchScreen(event) {
    console.log("MultiTouch : "+event.targetTouches.length);
    //navigator.app.exitApp();

    if(typeof(player.config) !== "undefined"){
      if(player.config.getQuitOnClick()){
          player.OS.quit();
      }
    }

    if (event.targetTouches.length > 5) {
        logger_visible = !logger_visible;
        player.setLogger(player.log_window);
        player.activateLogger(logger_visible);
        transfer.setLogger(player.log_window);
        transfer.activateLogger(logger_visible);
        manager.setLogger(player.log_window);
        manager.activateLogger(logger_visible);
    }
}

function activateConditionalAgents(activate){
    if(activate){
        //GEO
        if(!geo_watch_id){
            geo_watch_id = navigator.geolocation.watchPosition(onGeoUpdate, onGeoError, { timeout: 15000, enableHighAccuracy: true });
        }
        //SCREEN ORIENTATION
        window.addEventListener("orientationchange",onScreenOrientationChange);

    }else{
        navigator.geolocation.clearWatch(geo_watch_id);
        window.removeEventListener("orientationchange",onScreenOrientationChange);
    }
}

function onScreenOrientationChange(){
    console.log(screen.orientation);
    var timestamp = parseInt(new Date().getTime()/1000);
    var screen_orientation = {
        'id': 34,
        'filename': "screen_orientation.xml",
        'mdate': 0,
        'tstamp': timestamp,
        'version': "1.0",
        'status': "ok",
        'value': screen.orientation.type
    };
    conditional.writeConditionFile(screen_orientation);
}

function onGeoUpdate(position){
    var latitude = position.coords.latitude;
    var longitude = position.coords.longitude;
    var altitude = position.coords.altitude;
    var accuracy = position.coords.accuracy;
    var altitudeAccuracy = position.coords.altitudeAccuracy;
    var heading = position.coords.heading;

    if(conditional){
        var timestamp = parseInt(new Date().getTime()/1000);

        // Write latitude Condition
        var lat = {
            'id': 1,
            'filename': "lat.xml",
            'mdate': 0,
            'tstamp': timestamp,
            'version': "1.0",
            'status': "ok",
            'value': latitude
        };
        conditional.writeConditionFile(lat);

        // Write longitude Condition
        var lon = {
            'id': 2,
            'filename': "lon.xml",
            'mdate': 0,
            'tstamp': timestamp,
            'version': "1.0",
            'status': "ok",
            'value': longitude
        };
        conditional.writeConditionFile(lon);

        // Write heading Condition
        var head = {
            'id': 20,
            'filename': "heading.xml",
            'mdate': 0,
            'tstamp': timestamp,
            'version': "1.0",
            'status': "ok",
            'value': heading
        };
        conditional.writeConditionFile(head);

        // TODOs:
        // cordova-plugin-device-motion : accelerometer
        // cordova-plugin-device-orientation : screen orientation
    }
}

function onGeoError(event){
    console.log("GEO Error ... could not get position");
}
