'use strict';

var node_process = require('process');
var node_main = node_process.mainModule.exports;

var player = false;

// FOR ARM ARCH
var transfer = false;
var manager = false;


var beat_timer = false;
var service_timer = false;

var lastUserActivity = 0;

$(document).ready(function(){
    if(!service_timer){
        service_timer = setInterval(service,20000);
    }

    if(!player){
        player = new PlayerController();
        //player.activateLogger(true);
        $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
        player.init();
        player.OS.setMaxWindowDesktop();
        player.setPlayerWindow();
        // FIND A BETTER SOLUTION
        //player.OS.vanish();
        //player.OS.recover();
    }


    $(window).keypress(function(event){
        //console.log("KeyPress Code = "+event.which+" Shifted = "+self.keyboardShifted);
        lastUserActivity = parseInt(player.getDate().getTime()/1000);
    });

    $(window).on("mousemove",function(event) {
        //console.log("Mouse MOVE !!");
        lastUserActivity = parseInt(player.getDate().getTime()/1000);
    });

});

function beat(){
    /*
    var clipboard = nw.Clipboard.get();
    var clipboard_data = clipboard.get('text');
    if(clipboard_data == "1"){
        lastUserActivity = parseInt(player.getDate().getTime()/1000);
    }
    clipboard.clear();
    */
    if(!player.OS.window_showing){
        var playerMode = player.config.getMode();
        var playerModeTime = player.config.getModeTime();
         //console.log("NWJS Window beat! mode : "+playerMode+" : "+playerModeTime);
        if(playerMode == "1"){ // SCREENSAVER
            var now = parseInt(player.getDate().getTime()/1000);
            console.log("Now : "+now+" Last Activity : "+lastUserActivity);
            var spentTimeSinceLastActivity =  now - lastUserActivity;
            console.log("Spent Time : "+spentTimeSinceLastActivity);
            if(spentTimeSinceLastActivity > playerModeTime){
                console.log("Show Window !");
                if(!player.OS.window_showing){
                  player.OS.recover();
                  player.OS.togglePlayerMenu();
                }
            }
        }
    }
}

function service(){
    player.service();
    var playerMode = player.config.getMode();
    if(playerMode != "1" && !player.OS.player_paused_by_user){
        player.OS.recover();
        //player.OS.togglePlayerMenu();
    }
    player.OS.setMaxWindowDesktop();
    player.setPlayerWindow();
}

function onPlayerDataLoaded(){
    player.OS.setMaxWindowDesktop();
    player.setPlayerWindow();
    if(!beat_timer){
        beat_timer = setInterval(beat,1000);
    }

    player.log("LINUX Architecture is ARM : "+player.OS.isARM);
    if(!player.OS.isARM){
        node_main.init();
        node_main.update(player.timestamp,player.dataManager.getArchiveFiles(),player.version,player.debug,player.config.getScheduleConfig(),player.playlist.conditional);
    }else{
        if(!transfer){
            transfer = new TransferService();
            transfer.init(player.version);
        }
        transfer.update(player.timestamp,player.dataManager.getArchiveFiles());
        transfer.activateLogger(player.debug);
        if(!manager){
            manager = new ManagerService();
            manager.init();
        }
        manager.update(player.config.getScheduleConfig());
        manager.activateLogger(player.debug);
    }

    /* NOT NWJS 0.12 compatible
    chrome.runtime.sendMessage({action:"start",value:{core_id:player.core_id,version:player.version,timestamp:player.timestamp,archive:player.dataManager.getArchiveFiles()}}, function(val) {
            console.log("Chrome API : update Transfer");
    });
    */
}
