var main_soc = {
};

var player = null;
var transfer = false;
var manager = false;
var timerService = null;

$(document).ready(function(){
    player = new PlayerController();
    $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
    player.init();
    if(typeof(Worker) !== "undefined") {
        player.log("Web Workers available !!");
    } else {
        player.log("Web Workers NOT available :( ");
    }
});

function onPlayerDataLoaded(){
    $("#starter").hide();
    if(!transfer){
        transfer = new TransferService();
        transfer.setTimeCallback = player.setUseServerTime;
        transfer.init(player.version);
    }
    transfer.update(player.timestamp,player.dataManager.getArchiveFiles());
    transfer.activateLogger(player.debug);
    if(!manager){
        manager = new ManagerService();

        manager.init();
    }
    var scheduleConfig = player.config.getScheduleConfig();
    manager.update(scheduleConfig);
    manager.activateLogger(player.debug);

    if(transfer.bundle == "0" || transfer.bundle.substring(0,2) == "\r"){
        transfer.log("transfer.bundle.subString(0,2): "+transfer.bundle.substring(0,2));
        transfer.OS.readFile(transfer.ROUTES['VER'].path,function(data,file_ref,params){
            transfer.log("Bundle data VER : "+data);
            if(data != ""){
                transfer.bundle = data;
            }else{
                transfer.log("Trying to read file : "+player.ROUTES['MANIFEST'].path);
                transfer.OS.readFile(transfer.ROUTES['MANIFEST'].path,function(data,file_ref,params){
                    transfer.log("Bundle data : "+data);
                    if(data != ""){
                        var parser=new DOMParser();
                        var xmlDoc=parser.parseFromString(data,"text/xml");
                        transfer.bundle = xmlDoc.getElementsByTagName("ver")[0].childNodes[0].nodeValue;
                    }
                });
            }
        });
    }

    setTimeout(function(){
        transfer.log("transfer.bundle.subString(0,2): "+transfer.bundle.substring(0,2));
        if(transfer.bundle == "0" || transfer.bundle.substring(0,2) == "\r\n"){
            $.ajax({
                url:"/mtd_down/common/HospitalityBrowser/admira.ver",
                dataType:'text',
                cache: false,
                success: function( data3 ) {
                    if(data3.length > 0){
                        transfer.log("Bundle data VER 5 con ajax: "+data3);
                        transfer.bundle = data3;
                    }
                },
                error: function(e){
                    transfer.log("Error con el ajax de bundle");
                    transfer.OS.readFile("admira.ver",function(data4,file_ref,params){
                        if(data4 != "" && data4.length > 0){
                            transfer.log("Bundle data con readfile: "+data4);
                            transfer.bundle = data4;
                        }
                        else{
                            transfer.log("Error con el readfile de bundle");
                        }
                    })
                }
            });
        }
        transfer.OS.existsLIC();
        transfer.OS.existsCORE();
        transfer.OS.existsXMLS();
    },10000);

    setTimeout(function(){
      if(!timerService){
        timerService = new TimerService();
      }
      timerService.checkTimers(scheduleConfig);
    }, 15000);

}

function onKeyTV(){
    var keyCode = event.keyCode;
    switch (keyCode) {
        case player.OS.TV.KEY_LEFT:
            player.playlist.jump(-1);
            break;
        case player.OS.TV.KEY_RIGHT:
            player.playlist.jump();
            break;
        case player.OS.TV.KEY_UP:
            player.debug = !player.debug;
            player.setLogger($("#playerLog"));
            manager.setLogger($("#transferLog"));
            transfer.setLogger($("#transferLog"));
            player.activateLogger(player.debug);
            transfer.activateLogger(player.debug);
            break;
        case player.OS.TV.KEY_DOWN:
            break;
        case player.OS.TV.KEY_ENTER:
        case player.OS.TV.KEY_PANEL_ENTER:
            //player.update();
            break;
        default:
            player.log("TV : Unhandled key");
            break;
    }
}
