/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/* Compatible models:
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 *      - 
 */

// Export a convenience function that creates an instance
module.exports = function() {
  return new screen();
}

/*
 * INFORMATION TO SEND
 * itemScreen.last = item.lastCMD;
 * itemScreen.status = resolveScreenStatus(item); //  -1 ,0 1
 * itemScreen.id = item.id_screen;
 * itemScreen.tstamp = item.tstamp;
 * itemScreen.channel = item.channel;
 */

function screen() {
	
    // Reference to "this" that won't get clobbered by some other "this"
    var self = this;
    // Private state variables
    this.data = {
        id : null,
        remot_id : null,
        model : null
    }
    this.status = {
        power : -1,
        channel : -1,
        lastCMD : "",
        tstamp : 0
    }
    this.config = {
        port : null,
        schedule : null,
        delay : 0
    }
    //if (timer = 1) it will load if (timer = 0) it won't load
    this.timers = {
        power : 1,
        channel : 0,
        schedule : 1
    }
    this.protocol = null;
    this.scheduleUtils = require ('../utils/schedule.js');
    
    // Public method: initialize the object
    //self.init = function(options, callback) { ... }
    
    this.init = function ( screen ){
        self.data.id = screen.id;
        self.data.remot_id = screen.remot_id
        self.data.model = screen.model;
        
        self.config.port = screen.port;
        self.config.schedule = self.scheduleUtils.getBinSchedule(screen.schedule);
        
        self.protocol = require ('../protocolControllers/RS232.js')();
        self.protocol.init(
                self.config.port,
                { //parity and flow are none by default
                    baudRate : 9600,
                    dataBits : 8,
                    stopBits : 1
                },
                'readline' ,
                ':');
        //START CONTROL TIMERS
        if (self.timers.power)      self.timers.power       = setInterval ( function () { self.checkPowerStatus();      }, 5000);
        if (self.timers.channel)    self.timers.channel     = setInterval ( function () { self.checkChannelStatus();    }, 5000);
        if (self.timers.schedule)  self.timers.schedule   = setInterval ( function () { self.checkSchedule();        }, 5000);
    }
    
    this.stop = function (){
        if (self.timers.power)      clearInterval ( self.timers.power );
        if (self.timers.channel)    clearInterval ( self.timers.channel );
        if (self.timers.schedule)  clearInterval ( self.timers.schedule );
    }
/******************************** SEND STATUS ********************************/
    this.getStatus = function () {
        return { id : self.data.id , status : self.status } //V1 return status
        /* V2 return status
        return {
            id          : self.data.id ,
            tstamp      : self.status.tstamp,
            status      : self.status.power,
            channel     : self.status.channel,
            lastCMD     : self.status.lastCMD
        }*/
    }
    
/*********************************** POWER ***********************************/
    this.checkPowerStatus = function () {
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Start check power status" );
        self.protocol.sendAscii ( 'PWR?\r\n' , checkPowerStatusCallback );
    }
    //Private Callback
    checkPowerStatusCallback = function (err, data ){
        if (err){
            console.log(err);
            return;
        }
        
        //Translate Result to self.Status
        if (data == 'PWR=01\r' ){
            self.status.power = 1;
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOff();
        }else if (data == 'PWR=00\r'){
            self.status.power = 0;
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOn ();
        }else if (data == 'PWR=02\r'){ //Special case Loading lamp
            self.status.power = 1;
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOn ();
        }else if (data == 'ERR\r' ) {
            self.status.power = -1;
            self.status.tstamp = new Date().getTime()/1000;
        }else{
            self.status.power = -2;
            self.status.tstamp = new Date().getTime()/1000;
        }
        self.status.tstamp = new Date().getTime();
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Result check power status: " + self.status.power );

        /*
        //Get Schedule status

        
        //Check Schedule and state
        if (self.config.schedule && !self.status.power){
            self.turnOn ();
        }else if (!self.config.schedule && self.status.power){
            self.turnOff();
        }
        */
    }
    
/********************************** CHANNEL **********************************/
    this.checkChannelStatus = function (){
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Start check channel status" );
        self.protocol.sendAscii ( 'SOURCE?\r\n' , checkChannelStatusCallback );
    }
    //Private Callback
    checkChannelStatusCallback = function (err, data){
        if (err){
            console.log(err);
            return;
        }
        self.status.tstamp = new Date().getTime();
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Result check channel status: " + self.status.channel );
        /*
        Channels = {
            11 : 'RGB(Analog)',
            
        }*/
            
        //Translate Result to self.Status
        if (data == 'SOURCE=11\r' ){
            self.status.channel = 'RGB(Analog)';
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOff();
        }else if (data == 'SOURCE=14\r'){
            self.status.channel = 'Component';
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOn ();
        }else if (data == 'SOURCE=14\r'){
            self.status.channel = '';
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOn ();
        }else if (data == 'SOURCE=1F\r'){
            self.status.channel = 'Auto';
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOn ();
        }else if (data == 'SOURCE=30\r'){
            self.status.channel = 'HDMI';
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOn ();
        }else if (data == 'SOURCE=31\r'){
            self.status.channel = 'Digital-RGB';
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOn ();
        }/*else if (data == 'SOURCE=??\r'){
            self.status.channel = '';
            self.status.tstamp = new Date().getTime()/1000;
            //self.turnOn ();
        }*/else if (data == 'ERR\r' ) {
            self.status.channel = -1;
            self.status.tstamp = new Date().getTime()/1000;
        }else{
            console.log('-1')
            self.status.channel = -1;
            self.status.tstamp = new Date().getTime()/1000;
        }
        
    }
    
/********************************* SCHEDULLE *********************************/
    this.checkSchedule = function (){
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Start check schedule" );
        if ( self.status.power == -1 ){
            checkScheduleCallback( null, "Screen Disabled: Power -1");
        }else{
            if ( self.status.power != self.scheduleUtils.getScheduledPower ( self.config.schedule , self.config.delay) ){
                checkScheduleCallback( null, "Change needed");

                if ( self.scheduleUtils.getScheduledPower ( self.config.schedule , self.config.delay) ){
                    self.turnOn();
                }else{
                    self.turnOff();
                }
            }else{
                checkScheduleCallback( null, "OK");
            }
        }
    }
    //Private Callback
    checkScheduleCallback = function (err, data){
        if (err){
            console.log(err);
            return;
        }
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Result check schedule: " + data );
    }
    
    
    
//*********************************** MISC ***********************************/
    this.turnOn = function () {
        //self.screenData.status = 1;
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Start turn on" );
        self.protocol.sendAscii( 'PWR ON\r\n' , turnOnCallback);
    }
    //Private Callback
    turnOnCallback = function(err, data){
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Result turn on: " + data );
    }
    
    this.turnOff = function () {
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Start turn off");
        self.protocol.sendAscii( 'PWR OFF\r\n' , turnOnCallback);
    }
    //Private Callback
    turnOffCallback = function (err, data ){
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Result turn off: " + data );
    }

    this.sendFreeCommand = function ( command ) {
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Start send free command");
        self.protocol.sendAscii( command , sendFreeCommandCallback);
    }
    //Private Callback
    sendFreeCommandCallback = function (err, data ){
        console.log ( new Date() + ' - EPSON RS232 V1, screen: '+ self.data.id + " : Result send free command: " + data );
    }

    // Private functions can exist in the closure too; they can see the state but
    // outsiders can't touch them

    //function private() { ... }
    
}
