function FileManagerService(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "FileManagerService"; // MANDATORY

    this.MAX_DOWNLOAD_RETRIES = 5;
    this.downloading = false;
    this.archive = false;
    this.archive_index = 0;
    this.busy = false;
    this.busyCount = 0;
    this.busyCountXML = 0;
    this.library = [];
    this.lastLibraryCount = -1;
    this.initiated = false;

    this.update = function(new_archive){
        self.archive = null;
        self.archive = [];
        self.getWeeklyArchive();
    };
    this.checkDataXML = function(timestamp,callback){
        self.OS.fileExists(self.ROUTES['XML'].path+timestamp+".zip", function(exists,file_ref,index){
            if(!exists){
                self.log("Downloading ... busy... "+self.busyCountXML);
                self.busyCountXML++;
                if(self.busyCountXML > 5){
                    self.downloading = false;
                    //self.OS.cancelDownload();
                }
            }else{
                self.downloading = false;
                self.busyCountXML = 0;
                self.OS.unzipFile(self.ROUTES['XML'].path+timestamp+".zip",self.ROUTES['XML'].path,function(ok,file_ref,params){
                    self.OS.writeFile(self.ROUTES['XML'].path+self.ROUTES['TIMESTAMP'].path,params.xml_timestamp);
                    self.OS.deleteFile(self.ROUTES['XML'].path+timestamp+".zip");
                    if(typeof(callback) !== "undefined"){
                        callback(ok,params);
                    }
                },{'xml_timestamp':timestamp});
            }
        });
    };
    this.downloadDataXML = function(timestamp,callback,callback_error){
        self.downloading = true;
        var url = self.api_connector.buildUrl(self.api_url,self.api_ver,"player/download_playlist_week/id/"+self.core_id+ "/zip/1/"+self.getDate(true).getTime());
        var options = {'filename':timestamp+'.zip','xml_timestamp':timestamp};
        self.OS.downloadFile(url,self.ROUTES['XML'].path,function(ok,file_ref,params){
            self.downloading = false;
            self.busyCountXML = 0;
            if(ok){
                self.log("Playlist Files Download OK : "+url+" to "+self.ROUTES['XML'].path);
                var file_options = params;
                self.OS.unzipFile(self.ROUTES['XML'].path+timestamp+".zip",self.ROUTES['XML'].path,function(ok,file_ref,params){
                    self.OS.writeFile(self.ROUTES['XML'].path+self.ROUTES['TIMESTAMP'].path,params.xml_timestamp);
                    self.OS.deleteFile(self.ROUTES['XML'].path+timestamp+".zip");
                    if(typeof(callback) !== "undefined"){
                        callback(ok,params);
                    }
                },file_options);
            }else{
            	self.log(self.ERROR['FILE_MANAGER_SERVICE']+1,self.name+": Function downloadDataXML() failed : could not Download XML Week ");
                self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+1,self.name+": Function downloadDataXML() failed : could not Download XML Week ");
                if(typeof(callback_error) !== "undefined"){
                    callback_error(ok,params);
                }
            }
        },options);
    };

    this.downloadPendingFilesInArchive = function(){
        try{
            if(!self.archive){
                self.log("Waitting for archive to be set ...");
            }else{
                if(typeof(self.archive[self.archive_index]) !== "undefined"){
                    if(!self.busy){
                        var needs_download = false;
                        var security_stop = self.archive.length*2;
                        while(!needs_download && security_stop >= 0){
                            if(self.archive_index >= self.archive.length-1){
                                self.archive_index = 0;
                            }else{
                                self.archive_index++;
                            }
                            if(!self.archive[self.archive_index].downloaded){
                                if(self.archive[self.archive_index].ready){
                                    self.log("No attachs, go ! "+self.archive[self.archive_index].filename);
                                    needs_download = true;
                                }else{
                                    if(typeof(self.archive[self.archive_index].attachments) != "boolean"){
                                        self.archive[self.archive_index].ready = true;
                                        for(var i=0;i<self.archive[self.archive_index].attachments.length;i++){
                                            var index = self.archive[self.archive_index].attachments[i].index;
                                            if(!self.archive[index].downloaded){
                                                self.archive[self.archive_index].ready = false;
                                                break;
                                            }
                                        }
                                        if(self.archive[self.archive_index].ready){
                                            self.log("All attachs ok, go ! "+self.archive[self.archive_index].filename);
                                            needs_download = true;
                                        }else{
                                            self.log("Some attachs needed, wait ! "+self.archive[self.archive_index].filename);
                                        }
                                    }
                                }
                            }
                            security_stop--;
                        }
                        if(!self.archive[self.archive_index].downloaded){
                            self.busy = true;
                            self.OS.fileExists(self.ROUTES['CONTENT'].path+self.archive[self.archive_index].filename, function(exists,file_ref,index){
                                var status_for = {
                                    id:self.archive[self.archive_index].identifier,
                                    player:self.core_id,
                                    name:self.name
                                };
                                if(!exists){
                                  self.getStatusFile(status_for,function(data,params){
                                    var proceed_download = false;
                                    var checked_download_retries = 0;
                                    if(typeof(data) == "boolean" && !data){
                                      proceed_download = true;
                                    }else{
                                      if(typeof(data.retries) !== "undefined"){
                                        checked_download_retries = data.retries;
                                      }
                                      if(typeof(data.tstamp) !== "undefined"){
                                          if(data.tstamp != self.archive[self.archive_index].tstamp){
                                            self.log("New Timestamps : "+data.tstamp+" != "+self.archive[self.archive_index].tstamp+" for file ... setting retries to 0 to start downloading again.");
                                            checked_download_retries = 0;
                                          }
                                      }
                                      if(checked_download_retries < self.MAX_DOWNLOAD_RETRIES){
                                        proceed_download = true;
                                      }
                                    }
                                    if(proceed_download){
                                      var url = "";
                                      self.log("Downloading : "+url);
                                      var content_type = "";
                                      if(typeof(self.archive[self.archive_index].attachments) == "boolean"){
                                        content_type = "Adjunto";
                                        url = self.archive[self.archive_index].url;
                                      }else{
                                        content_type = "Video";
                                        url = self.api_connector.protocol+self.api_server_url+self.archive[self.archive_index].url;
                                      }
                                      var params = {
                                          file_ref:file_ref,
                                          content_id:self.archive[self.archive_index].id,
                                          content_type:content_type,
                                          hash:self.archive[self.archive_index].hash,
                                          retries: checked_download_retries
                                      };
                                      self.OS.downloadFile(url,self.ROUTES['CONTENT'].path,self.onFileDownloadComplete,params);
                                    }else{
                                      self.busy = false;
                                      self.log("Max Download Retries Exceeded for file "+self.archive[self.archive_index].filename+" please check connection.");
                                      self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+7,self.name+": Function downloadPendingFilesInArchive() Max Download Retries Exceeded for file "+self.archive[self.archive_index].filename+" please check connection.");
                                    }
                                  },{index:self.archive_index});
                                }else{
                                    self.log(self.archive[self.archive_index].filename+" already exists ...");  
                                    self.getStatusFile(status_for,self.checkFileTimestamp,{index:self.archive_index});
                                    self.busy = false;
                                    self.busyCount = 0;
                                    self.downloadPendingFilesInArchive();
                                }
                            });
                        }
                        else{
                            self.log("All needed files download complete ! hurray !");
                        }
                    }else{
                        self.OS.fileExists(self.ROUTES['CONTENT'].path+self.archive[self.archive_index].filename, function(exists,file_ref,index){
                            if(!exists){
                                self.log("Downloading ... busy");
                                self.busyCount++;
                                if(self.busyCount > 30){
                                    self.busy = false;
                                    self.busyCount = 0;
                                    self.archive_index++;
                                }
                            }else{
                                self.log(self.archive[self.archive_index].filename+" already exists ...");
                                var status_for = {
                                    id:self.archive[self.archive_index].identifier,
                                    player:self.core_id,
                                    name:self.name
                                };
                                self.getStatusFile(status_for,self.checkFileTimestamp,{index:self.archive_index});
                                self.busy = false;
                                self.busyCount = 0;
                                self.downloadPendingFilesInArchive();
                            }
                        });
                    }
                    self.OS.readDirectory(self.ROUTES['CONTENT'].path,self.checkContentDirectory);
                }else{
                    self.busy = false;
                    self.busyCount = 0;
                    self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+5,self.name+": Function downloadPendingFilesInArchive() failed : archive file looks invalid on index : "+self.archive_index);
                    self.archive_index = 0;
                }
            }
        }
        catch(e){
            self.log(".....................................downloadPendingFilesInArchive -- catch");
            self.log(JSON.stringify(e));
        }

    };

    this.checkFileTimestamp = function(data,params){
        var download_retries = 0;
        if(typeof(params.index) !== "undefined"){
            var archive_file_stamp = false;
            if(typeof(data) == "boolean" && !data){
                archive_file_stamp = true;
                //self.log("File exists archiving data tstamp.");
                self.archive[params.index].downloaded = true;
            }else{
                if(typeof(data.retries) !== "undefined"){
                  download_retries = data.retries;
                }
                if(typeof(data.tstamp) !== "undefined"){
                    if(data.tstamp == self.archive[params.index].tstamp){
                        //self.log("File exists and it's up to date.");
                        self.archive[params.index].downloaded = true;
                    }else{
                        self.log("File exists but it's old ... deleting for re-download");
                        self.OS.deleteFile(self.ROUTES['CONTENT'].path+self.archive[params.index].filename);
                        self.archive[params.index].downloaded = false;
                        download_retries = 0;
                        archive_file_stamp = true;
                    }
                }else{
                    archive_file_stamp = true;
                    //self.log("File exists archiving data tstamp.");
                    self.archive[params.index].downloaded = true;
                    //self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+6,self.name+": Function checkFileTimestamp() failed : could not check saved tstamp for content: "+self.archive[params.index].id);
                }
            }
            if(archive_file_stamp){
                var download_status = {
                    id: self.archive[params.index].identifier,
                    player: self.core_id,
                    name: self.name,
                    filename: self.archive[params.index].filename,
                    tstamp: self.archive[params.index].tstamp,
                    retries: download_retries
                };
                self.saveStatusFile(download_status);
            }
        }else{
            self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+6,self.name+": Function checkFileTimestamp() failed : could not check index for existing file ... marking as downloaded");
        }
    };

    this.onFileDownloadComplete = function(ok,url,params){
        self.busy = false;
        var download_retries = 0;
        if(typeof(params) != "undefined"){
          if(typeof(params.retries) != "undefined"){
            download_retries = params.retries;
            download_retries++;
          }
        }
        if(typeof(self.archive[self.archive_index]) !== "undefined"){
          var filename = params.file_ref.substring(params.file_ref.lastIndexOf("/")+1,params.file_ref.length);
          if(ok){download_retries = 0;}
          var download_status = {
              id: self.archive[self.archive_index].identifier,
              player: self.core_id,
              name: self.name,
              filename: filename,
              tstamp: self.archive[self.archive_index].tstamp,
              retries: download_retries
          };
          self.saveStatusFile(download_status);
          if(ok){
            self.log("Download File completed");
            self.archive[self.archive_index].downloaded = true;
            self.notifyDownload(filename,params.content_id,params.content_type);
            if(params.content_type == "Adjunto"){
              self.downloadPendingFilesInArchive();
            }
          }else{
              self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+2,self.name+": Function onFileDownloadComplete() failed : could not Download file : "+self.archive[self.archive_index].filename+" from "+url);
              self.log(self.archive[self.archive_index].filename+" download error !!!");
          }
        }
    };

    this.notifyDownload = function(filename,content_id,content_type){

        var data = "id="+self.core_id+"&content="+filename+"&content_id="+content_id+"&type="+content_type;
        self.log("Sending download notificacion : "+data.toString());
        self.api_connector.post(self.api_url,self.api_ver,"player/downloaded",data,self.notifyDownloadResponse);
    };

    this.notifyDownloadResponse = function(response,status,params){
        if(status == "success"){
            self.log("Download notified");
        }else{
            self.log("Download could not be notified");
            self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+4,self.name+": Function notifyDownloadResponse() failed : could not notify a download.");
        }
    };

    this.checkContentDirectory = function(files){
        self.log("Checking Content Directory .... ");
        if(self.archive){
            var index = 0;
            self.library = [];
            for(var k=0;k<self.archive.length;k++){
                self.archive[k].downloaded = false;
            }
            for(var i=0;i<files.length;i++){
                var file = files[i];
                self.log("/content/ : "+file);
                if(file != ""){
                    if(self.platform == "SOC"){
                        file = file.substring(2,file.length-1);
                    }
                    index = self.archive.map(function(e){return e.filename;}).indexOf(file);
                    if(index == -1){
                        try{
                            self.log("Deleting unneeded file : "+file);
                            self.OS.deleteFile(self.ROUTES['CONTENT'].path+file);
                        }catch(ex){
                            self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+3,self.name+": Function checkContentDirectory() failed : error while deleting old content");
                            self.log("Error while deleting ... "+file);
                            self.log(ex.toString());
                        }
                        if(typeof(self.archive[index]) !== "undefined"){
                            library_index = self.library.indexOf(self.archive[index].id);
                            if(library_index >= 0){
                                self.log("File is in library and shouldn't ... removing : "+file);
                                self.library.splice(1,self.archive[index].id);
                            }
                        }
                    }else{
                        if(typeof(self.archive[index]) !== "undefined"){
                            self.archive[index].downloaded = true;
                            var status_for = {
                                id:self.archive[index].identifier,
                                player:self.core_id,
                                name:self.name
                            };
                            self.getStatusFile(status_for,self.checkFileTimestamp,{index:index});

                            library_index = self.library.indexOf(self.archive[index].id);
                            if(library_index == -1){
                                if(self.archive[index].id){
                                    //self.log("File is not in library ... adding : "+file);
                                    self.library.push(self.archive[index].id);
                                }else{
                                    self.log("File is an attachment : not included in Library");
                                }
                            }
                        }
                    }
                }
            }
            self.initiated = true;
            self.log("Actual library elements : "+self.library.length);
        }
    };

    this.getWeeklyArchive = function(dow,count){
        if(typeof(count) === "undefined"){count = 1;}
        if(typeof(dow) === "undefined"){
            dow = self.getDayOfWeek();
        }else{
            if(dow == 7){ //check!!! if dow == 8 ??
                dow = 1;
            }else{
                dow++;
            }
        }
        if(count <= 7){
            self.OS.readFile(self.ROUTES['XML'].path+dow+".xml",function(data,filename,params){
              var dataManager = new DataManagerController();
              $(dataManager).one("DataManagerControllerDataLoaded",{'dow':dow,'count':count},self.onDataLoaded);
              $(dataManager).one("DataManagerControllerDataError",{'dow':dow,'count':count},self.onDataError);
              try{
                dataManager.loadDataXML(data);
              }catch(e){
                  self.onDataError({'data':{'dow':dow,'count':count}});
              }            
            });
            
        }else{
            self.log("Weekly Archive Finished with files "+self.archive.length);
        }
    };

    this.onDataLoaded = function(e){
        self.archive = e.currentTarget.getArchiveFiles(self.archive);
        e.data.count++;
        self.getWeeklyArchive(e.data.dow,e.data.count);
    };

    this.onDataError = function(e){
        self.log("Error on DataManagerController for DOW : "+e.data.dow+" try next day ...");
        e.data.count++;
        self.notifyError(self.ERROR['TRANSFER_SERVICE']+16,self.name+": Function getWeeklyArchive()  :  Error on DataManagerController for DOW : "+e.data.dow+" try next day ...");
        self.getWeeklyArchive(e.data.dow,e.data.count);
    };

}
FileManagerService.prototype = new BasicService();
