function ScreenService(){
    if(arguments.callee._singletonInstance){
        return arguments.callee._singletonInstance;
    }
    arguments.callee._singletonInstance = this;

    var self = this; self.name = "ScreenService"; // MANDATORY
    this.license = new RegisterService();
    
    this.screenDatas = []
    this.screenControllers = []
    this.screenCounter = 0;
    this.screenStatus = false;
    
    this.checkScreensTimer = null;
    this.screenStatus_timer = 0;
    this.screenStatus_interval = 20000;

    this.started = null;
    this.bundle = null;
    this.xml_timestamp = null;
    this.player_version = null;

    this.init = function(started, bundle, xml_timestamp, player_version){
        self.started = started;
        self.bundle = bundle;
        self.xml_timestamp = xml_timestamp;
        self.player_version = player_version;
        self.update(started, bundle, xml_timestamp, player_version);
        if(!self.screenStatus_timer){
            self.screenStatusF();
        }
    }
    
    this.update = function (started, bundle, xml_timestamp, player_version) {
        self.started = started;
        self.bundle = bundle;
        self.xml_timestamp = xml_timestamp;
        self.player_version = player_version;
        self.log("Updating screens: ");
        //self.OS.readFile(self.OS.rootDir+self.ROUTES['XML'].path+dow+".xml",function(data,filename,params){
        self.OS.readFile(self.OS.rootDir+self.ROUTES['XML'].path+"1"+".xml",function(data,filename,params){
            var dataManager = new DataManagerController();
            $(dataManager).one("DataManagerControllerDataLoaded",{},self.onDataLoaded);
            $(dataManager).one("DataManagerControllerDataError",{},self.onDataError);
            dataManager.loadDataXML(data);
        });
        
    }
    
    this.load = function () { 
        clearInterval ( self.checkScreensTimer );
        console.log ( new Date() + ' - Screen Manager: Update screens: Start' );
        self.screenControllers.forEach ( function (screenController ) {
            screenController.stop();
        })
        self.screenControllers = []
        if (self.screenDatas.length > 0 ){
            self.screenDatas.forEach ( function ( data ) {
                self.screenCounter++;
                var controller = self.OS.generateNewScreenController ( data, self.platform, self.screenCounter);
                if ( controller ){
                    self.screenControllers.push ( controller );
                }
            })
            clearTimeout(self.checkScreensTimer);
            self.checkScreensTimer = setTimeout ( self.checkScreens, 5000);
        }
        console.log ( new Date() + ' - Screen Manager: Update screens: ' + self.screenControllers.length + ' screens' );
    }
    
    
    this.onDataLoaded = function(e){
        self.log("Load on DataManagerController for screens");
        self.screenDatas = e.currentTarget.getScreens();
        self.load();

    };

    this.onDataError = function(e){
        self.log("Error on DataManagerController for screens");
        self.notifyError(self.ERROR['SCREEN_SERVICE']+16,self.name+": Function getScreens()  :  Error on DataManagerController for screens");
    };
    
    
    this.checkScreens = function  () {
        clearTimeout(self.checkScreensTimer);
        self.checkScreensTimer = setTimeout ( self.checkScreens, 5000);
        var status =[];
        try {
            self.screenControllers.forEach ( function ( status ) {
                this.push ( status.getStatus() );
            }, status )
        }catch (error){
            console.log(error);
            clearTimeout(self.checkScreensTimer);
            self.checkScreensTimer = setTimeout ( self.checkScreens, 5000);
        }
        try {
            if ( status.length > 0 ){
                self.screenStatus = status
            }else{
                self.screenStatus = false
            }
        }catch (error){
            console.log(error);
            clearTimeout(self.checkScreensTimer);
            self.checkScreensTimer = setTimeout ( self.checkScreens, 5000);
        }
        
        clearTimeout(self.checkScreensTimer);
        self.checkScreensTimer = setTimeout ( self.checkScreens, 5000);
    }
    
    this.getStatus = function (){
        return self.screenStatus;
    }



    this.screenStatusF = function(){
        clearTimeout(self.screenStatus_timer);
        if(self.screenDatas.length > 0){
            if(!self.OS.busy){
              //if(self.internet_connected && self.started){
                  self.log("# Screen status beat ... ");
                //  if(self.license.registered){
                      var data = self.getScreenStatusData();
                      self.log("Sending screen status for player : "+self.core_id);
                      //self.log(JSON.stringify(data));
                      self.api_connector.post(self.api_url, "2.0", "player/alive",data,self.screenStatusResponse);
                  //}
              //}
              self.screenStatus_timer = setTimeout(self.screenStatusF,self.screenStatus_interval);
            }else{
                self.screenStatus_timer = setTimeout(self.screenStatusF,5000);
                self.log("# Screen status beat ... CANCELED ... OS is busy");
            }
        }
        else{
            self.screenStatus_timer = setTimeout(self.screenStatusF,300000);
        }
        
    };
    
    this.screenStatusResponse = function(response,status,params){
        if(status == "success"){
          self.log("# Screen status response ... success");
          self.log(response);
        }
    };

    this.getScreenStatusData = function(){
        var playlist_status = {
                id: "position",
                player:self.core_id,
                name: "PlaylistController"
            };
        self.getStatusFile(playlist_status,function(data,params){
            if(typeof(data) !== "undefined"){
                if(typeof(data.pass) !== "undefined"){
                    if(!isNaN(data.pass)){
                        self.pass = data.pass;
                    }
                }
            }
        });
        var data = {
            id: self.core_id,
            status: 1,
            content_id : self.OS.id_content_now,
            xml_day: self.xml_timestamp,
            xml_timestamp: self.xml_timestamp,
            xml_week: self.xml_timestamp,
            system: self.platform,
            vtransfer: self.version,
            vplayer: self.player_version,
            bundle: self.bundle,
            pase: self.pass
        }
        console.log ("*****************************")
        //if(self.screen_manager){
            var devices = self.getStatus();
            if ( devices ){
                console.log ("*****************************")
                console.log (devices)
                data.devices = JSON.stringify(devices);
                self.log (data.devices);
            }
        //}
        return data;
    };
}
ScreenService.prototype = new BasicService();
